(function () {
// 输出信息
function mxLog(info) {
	var debugMode = getDebugMode();
	if (debugMode && info) {
		console.log(info);
	}
}

// 保存用来存放slide的div
var g_slide_div = null;
function getSlideDiv() {
	return g_slide_div;
}

function setSlideDiv(div) {
	g_slide_div = div;
}

// 保存所有的游戏信息
var g_game_info_arr = null;
// Private API
function getGameInfoArr() {
	return g_game_info_arr;	
}

// Private API
function setGameInfoArr(arr) {
	g_game_info_arr = arr;	
}

// Private API
// 创建一个能够启动游戏的img图标节点
// <img class="game-icon"  src="images/fruit/fruit_256x256.png" onclick="mgeFunc(event);" mgeurl="mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPWZydWl0"/>
function createGameIconElement(gameUrl, iconSrc, setClickEvent) {
	if (gameUrl && iconSrc) {		
		var oImg = document.createElement("img");
		oImg.className = "game-icon";
		oImg.src = iconSrc;
		if (setClickEvent) {
			oImg.setAttribute("onclick", "mgeFunc(event);");		 
			oImg.setAttribute("mgeurl", gameUrl);
		}
		return oImg;
	} else {
		mxLog("ERROR game-center.js : mgeUrl or iconSrc is not correct!");
		return null;
	}
}

// Private API
// 找到离node节点最近的tagName类型节点
function getNearestElement(node, tagName) {
	var oElement = null;
	
	if (tagName) {
		var parent = node;
		while (parent) {
			if (parent.tagName.toLowerCase() == tagName.toLowerCase()) {
				oElement = parent;
				break;	
			}
			
			parent = parent.parentNode;
		}
	}
	return oElement;
}

// Private API
// 获取最近的td节点
function getNearestTdElement(node) {
	var oTd = getNearestElement(node, "td");
	
	return oTd;
}

// 我的游戏中的slide对象
var g_slide = null;
// Private API
function getSlide() {
	return g_slide;
}

// Private API
function setSlide(slide) {
	g_slide = slide;
}

// Private API
// 根据td节点，获取对应的数组索引
function getArrayIndex(td) {
	var tdIndex = 0;	
	var oTd = td;
	var oTr = oTd.parentNode;
	for (var child=oTr.firstChild; child && child != oTd; child = child.nextSibling) {
		tdIndex++;
	}
	
	var slide = getSlide();
	var sliderIndex = slide.getCurrentSlide();	
	var count = getIconCountPerPage();
	tdIndex += sliderIndex*count;
	
	return tdIndex;	
}

// Public API
//<div id="myGame">
//	<div id="myGameSlide">
//	</div>
//</div>
// 表示删除我的游戏中的某个游戏
window.doDeletion = function (event) {
	// 阻止事件继续传递和默认行为
	event.stopPropagation();
	event.preventDefault();
	
	// 将parentDiv下面的内容重新进行设置
	var slideDiv = getSlideDiv();
	slideDiv.innerHTML = "<div id='myGameSlide'></div>";
	
	var oMyGame = slideDiv.firstChild;
	
	var gameInfoArr = getGameInfoArr();
	
	var target = event.target;
	var oTd = getNearestTdElement(target);
	var tdIndex = getArrayIndex(oTd);
	var length = gameInfoArr.length;
	// 复制相应的位置信息
	for (var i=0; i<length-tdIndex-1; i++) {
		gameInfoArr[length-1-i].left = gameInfoArr[length-2-i].left;
	}
	// 删除相应位置的数组元素
	gameInfoArr.splice(tdIndex, 1);
	
	var count = getIconCountPerPage();
	
	var slide = getSlide();	
	var sliderIndex = slide.getCurrentSlide();
		
	createAllGameIconElementInternal(oMyGame, gameInfoArr, count, sliderIndex);	
}

// Private API
// 创建表示删除状态的叉形图标
function createDeletionIcon () {
	var oDiv = document.createElement("div");
	oDiv.setAttribute("align", "center");
	oDiv.setAttribute("style","display:inline-block; width:20px; height:20px; background-color:red; border:1px solid white; border-radius:20px; color:white; font-size:18px;");
	oDiv.setAttribute("onclick", "doDeletion(event)");
	
	oDiv.innerHTML = "×";
	
	return oDiv;
}

// Private API
// 进入删除模式
// 元素的位置参数需要根据实际情况进行调整。
function enterDeletionMode (target, index) {
	var parent = target.parentNode;
	var oldIndex = index;
	// 小于0，表明这是用户主动长按调用过来的。
	
	if (oldIndex < 0) {
		var oTd = getNearestTdElement(target);
		index = getArrayIndex(oTd);
	}
	
	var deletionIcon = createDeletionIcon();
	
	var rect = target.getBoundingClientRect();
	
	deletionIcon.style.position = "relative";
	deletionIcon.style.left = rect.width - 25 + "px";;
	deletionIcon.style.top = -5 + "px";
	
	var oDiv = document.createElement("div");				
	oDiv.style.position = "absolute";
	var gameInfoArr = getGameInfoArr();	
	if (oldIndex < 0) {
		var slide = getSlide();		
		var currentPage = slide.getCurrentSlide();
		var count = getIconCountPerPage();
		var start = currentPage*count;
		var td = getNearestTdElement(target);
		var tr = td.parentNode;
		var tdChild = tr.firstChild;
		for (var i=0; i<count; i++) {
			var myRect = tdChild.getBoundingClientRect();
			var gameInfo = gameInfoArr[start+i];
			if (!gameInfo) {
				break;	
			}
			gameInfo.left = document.body.scrollLeft + myRect.left - 5 + "px";
			
			tdChild = tdChild.nextSibling;
		}
		oDiv.style.left = document.body.scrollLeft + rect.left - 5 + "px";
		gameInfoArr[index].left = oDiv.style.left;
	} else {
		oDiv.style.left = gameInfoArr[index].left;
	}
	oDiv.style.top = "5px";//document.body.scrollTop + rect.top + "px";
	oDiv.style.width = rect.width - 10 + "px";
	oDiv.style.height = rect.height - 10 + "px";
	// 调试的时候可以打开这个边框
	//oDiv.style.border = "1px red solid";
	oDiv.setAttribute("onclick", "exitDeletionMode(event)");
	
	oDiv.appendChild(deletionIcon);
	
	parent.appendChild(oDiv);
	
	gameInfoArr[index].isInDeletionMode = true;
}

// Private API
// 退出删除模式
function exitDeletionMode(event) {
	var target = event.target;
	var oTd = getNearestTdElement(target);
	var index = getArrayIndex(oTd);
	var gameInfoArr = getGameInfoArr();	
	gameInfoArr[index].isInDeletionMode = false;
	
	target.parentNode.removeChild(target);

	
}

// Public API
// 检测是否为长按，2s即可触发长按事件响应
var g_time_out = null;
window.mgeTouchStart = function (event) {
	g_time_out = window.setTimeout(function () { enterDeletionMode(event.target, -1); }, 2000);
}

// Public API
// 如果触摸结束，则清除定时器
window.mgeTouchEnd = function (event) {
	window.clearTimeout(g_time_out);
	g_time_out = null;
}

// Private API
// 根据传入的参数在指定的节点下面穿件创建所有的孩子节点
//<table>
//	<tr>
//		<td scope="col" class="column-icon">
//			<img class="game-icon" src="images/fruit/fruit_256x256.png" onclick="mgeFunc(event);"
//			mgeurl="mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPWZydWl0">
//		</td>
//		<td scope="col" class="column-icon">
//			<img class="game-icon" src="images/flappy/flappy_256x256.png" onclick="mgeFunc(event);"
//			mgeurl="mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPWJpcmQ=">
//		</td>
//		<td scope="col" class="column-icon">
//			<img class="game-icon" src="images/2048/2048_256x256.png" onclick="mgeFunc(event);"
//			mgeurl="mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPTIwNDg=">
//		</td>
//		<td scope="col" class="column-icon">
//			<img class="game-icon" src="images/pop/pop_256x256.png" onclick="mgeFunc(event);"
//			mgeurl="mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPXBvcHN0YXI=">
//		</td>
//	</tr>
//	<tr class="gameName">
//		<td>
//			水果忍者
//		</td>
//		<td>
//			Flappy Bird
//		</td>
//		<td>
//			2048
//		</td>
//		<td>
//			Pop Stars
//		</td>
//	</tr>
//</table>
//<img class="game-icon" src="images/flappy/flappy_256x256.png" onclick="mgeFunc(event);"  ontouchend="mgeTouchEnd(event)" mgeurl="mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPWJpcmQ=" ontouchstart="mgeTouchStart(event)"  ontouchmove="mouseMove(event)" onmouseup="mgeTouchEnd(event)"  onmousedown="mgeTouchStart(event)">
function createAllGameIconElementInternal(parent, gameInfoArray, gameCount, sliderIndex) {
	if (parent && gameInfoArray) {
		// 如果没有传入gameCount参数，那么默认为4
		if (gameCount!=0 && !gameCount) {
			gameCount = getIconCountPerPage();
		}
		
		if (!sliderIndex) {
			sliderIndex = 0;
		}
		
		var length = gameInfoArray.length;
		var newGameInfoArr = [];
		for (var i=0; i<length; i+=gameCount) {
			var arr = gameInfoArray.slice(i, i+gameCount);
			newGameInfoArr.push(arr);
		}
		
		// 保存gameIcon节点
		var imgArr = [];
		
		var length2 = newGameInfoArr.length;
		
		for (var j=0; j<length2; j++) {
			var gameInfoArr = newGameInfoArr[j];
			// 创建一个表格
			var oTable = document.createElement("table");
			var oTBody = document.createElement("tbody");
			oTable.appendChild(oTBody);
			
			// 创建一个行对象，并插入到表格中
			var oTr = document.createElement("tr");
			oTBody.appendChild(oTr);
			
			// 创建另外一个行对象，并插入到表格中
			var oTr2 = document.createElement("tr");
			oTr2.setAttribute("class", "game-name");
			oTBody.appendChild(oTr2);
					
			var length3 = gameInfoArr.length;
			for (var k=0; k<gameCount; k++) {
				// 创建一个列对象用来放入游戏图标节点
				var oTd = document.createElement("td");
				oTd.setAttribute("scope", "col");
				oTd.setAttribute("class", "column-icon");
				
				// 创建一个列对象用来放入游戏名字
				var oTd2 = document.createElement("td");
				
				// 只有存在实际要显示的游戏图标和游戏名字时才需要
				// 创建相应的图标节点和文字节点；否则只创建td节点
				// 进行占位
				if (k<length3) {
					var gameInfo = gameInfoArr[k];			
					var gameUrl = gameInfo.gameUrl;//"mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPWZydWl0";
					var iconSrc = gameInfo.iconSrc;//"images/fruit/fruit_256x256.png";
					var oGameIcon = createGameIconElement(gameUrl, iconSrc, false);
					// 为img节点增加触控响应
					oGameIcon.setAttribute("ontouchstart", "mgeTouchStart(event)");
					oGameIcon.setAttribute("ontouchend", "mgeTouchEnd(event)");	
					// 兼容不支持触控的桌面浏览器
					oGameIcon.setAttribute("onmousedown", "mgeTouchStart(event)");	
					oGameIcon.setAttribute("onmouseup", "mgeTouchEnd(event)");											
					// 将img节点插入到列对象中，
					// 然后把列对象插入到行对象中
					oTd.appendChild(oGameIcon);
					// 保存起来方便后面使用
					imgArr.push(oGameIcon);
					
					var gameName = gameInfo.gameName;
					oTd2.innerHTML = gameName;
				}
				
				oTr.appendChild(oTd);
				oTr2.appendChild(oTd2);
			}
			
			var oLi = document.createElement("li");
			oLi.appendChild(oTable);
			parent.appendChild(oLi);
		}
		
		var slide = $('#myGameSlide').bxSlider({startSlide:sliderIndex});
		setSlide(slide);
		
		var imgArrSize = imgArr.length;
		for (var m=0; m<imgArrSize; m++) {
			var gameInfo = gameInfoArray[m];
			var isInDeletionMode = gameInfo.isInDeletionMode;
			if (isInDeletionMode) {
				var img = imgArr[m];
				enterDeletionMode(img, m);
			}
		}
	} else {
		mxLog("ERROR game-center.js : parent or gameInfoArr is not correct!");
	}
}

// 创建表示新游戏的提示标志
function createNewHintElement() {
	var oSpan = document.createElement("span");
	oSpan.setAttribute("class", "newHint");
	oSpan.innerHTML = "NEW";
	
	return oSpan;
}

// Private API
// 创建表示在玩该游戏的好友数的元素
function createFriendInfoElement(friendInfoStr) {
	var oSpan = document.createElement("span");
	oSpan.setAttribute("class", "friend-info");
	oSpan.innerHTML = friendInfoStr;
	
	return oSpan;
}

// Private API
// 创建表示游戏玩家数量的元素
function createPlayerNumElement(playerNum) {
	var oSpan = document.createElement("span");
	oSpan.setAttribute("class", "player-num");
	var languageInfo = getLanguageInfo();
	var playerInfoStr = languageInfo.playerNumInfoText(playerNum);
	oSpan.innerHTML = playerInfoStr;
	
	return oSpan;
}

// Private API
// 创建表示游戏简介的提示圆圈的元素
function createIntroHintElement() {
	var oDiv = document.createElement("div");
	oDiv.setAttribute("class", "introHint");
	oDiv.setAttribute("align", "center");
	oDiv.innerHTML = ">";

	return oDiv;	
}

// Private API
//<span class="game-intro">
//
//	<span style="font-size:12px; color:#a0abb0;">游戏简介</span><div class="introHint" align="center">></div>
//</span>
// 创建表示游戏简介的元素
function createGameIntroElement() {
	var oSpanText = document.createElement("span");
	oSpanText.setAttribute("style", "font-size:12px; color:#a0abb0;");
	var languageInfo = getLanguageInfo();
	oSpanText.innerHTML = languageInfo.gameIntroText;
	
	// 先去掉这个提示箭头
	//var oDiv = createIntroHintElement();
	
	var oSpan = document.createElement("span");
	oSpan.appendChild(oSpanText);
	// 先去掉这个提示箭头
	//oSpan.appendChild(oDiv);
	oSpan.setAttribute("class", "game-intro");
	
	return oSpan;
}

// Private API
// 创建表示快玩按钮的元素
// <span style="background-color:#1fb77f; font-size:10px; border-radius:15px; color:#FFF; padding:2px 8px;">快玩</span>
function createKuaiwanElement(gameUrl, setClickEvent) {
	var oSpan = null;
	if (gameUrl) {
		oSpan = document.createElement("span");		
		if (setClickEvent) {
			oSpan.setAttribute("onclick", "mgeFunc(event);");		 
			oSpan.setAttribute("mgeurl", gameUrl);
		}
		oSpan.setAttribute("style", "display:inline-block; background-color:#1fb77f; font-size:15px; border-radius:5px; color:#FFF; padding:4px 10px;");
		var languageInfo = getLanguageInfo();
		oSpan.innerHTML = languageInfo.kuaiwanText;

	} else {
		mxLog("ERROR game-center.js : gameUrl is null!");
	}
	
	return oSpan;
}

// Private API
// 根据传入的字符串创建一个用来表示id的唯一的字符串
var g_id_counter = 0;
function createIdStr() {
	g_id_counter++;
	return "mxStar" + g_id_counter;
}

// Public API
// 跳转到指定的url
window.gotoNewUrl = function(url) {
	if (url) {
		window.location.href = url;	
	} else {
		mxLog("game-center.js url is null or empty.");	
	}
}

// Private API
//<div class="row">
//  <table>
//		<tr>
//	  		<th scope="col" class="column-icon">        
//				<img class="game-icon" src="images/fruit/fruit_256x256.png" onclick="mgeFunc(event);" mgeurl="mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPWZydWl0"/>
//			</th>
//	 	 	<th scope="col" class="column-info"><div class="game-info">水果忍者<span class="newHint">NEW</span><br/>
//	  			<span class="friend-info">有24位好友在玩</span></div>
//			</th>
//	  		<th scope="col" class="column-star"><div id="starFruit"></div>
//			</th>
//		</tr>
//  </table>  
//	<script type="text/javascript">$('#starFruit').raty({ path: "star/images/", space: false, readOnly:true, score:5} );</script>    
//</div>
// 创建表示被推荐的游戏的描述对象
function createGameInfoElement(gameName, gameUrl, iconSrc, isNewGame, friendInfoStr, gameScore, detailUrl, playerNum) {
	if (gameName && gameUrl && iconSrc && friendInfoStr) {
		// 创建表示一行的div节点
		var oDivRow = document.createElement("div");
		oDivRow.setAttribute("class", "row");
		
		// 创建一个表格
		var oTable = document.createElement("table");
		oDivRow.appendChild(oTable);
		
		// 创建一个行对象，并插入到表格中
		var oTr = document.createElement("tr");
		var oTBody = document.createElement("tbody");
		
		oTr.setAttribute("onclick", "mgeFunc(event, false,'" + gameUrl+ "');");
		//oTr.setAttribute("mgeurl", gameUrl);
				
		oTBody.appendChild(oTr);
		oTable.appendChild(oTBody);
		
		// 创建一个列对象和一个表示游戏图标的img节点
		var oTd1 = document.createElement("td");
		oTd1.setAttribute("scope", "col");
		oTd1.setAttribute("class", "column-icon");
		//oTd1.setAttribute("onclick", "gotoNewUrl('" + detailUrl + "')");
		var oGameIcon = createGameIconElement(gameUrl, iconSrc, false);
		// 将img节点插入到列对象中，
		// 然后把列对象插入到行对象中
		oTd1.appendChild(oGameIcon);
		oTr.appendChild(oTd1);
		
		// 创建一个块对象
		var oDiv = document.createElement("div");
		oDiv.setAttribute("scope", "col");
		oDiv.setAttribute("class", "column-info");
		
		// 创建一个表示游戏信息的div对象
		var oDivGameInfo = document.createElement("div");
		oDivGameInfo.setAttribute("class", "game-info");
		var oGameName = document.createTextNode(gameName);
		oDivGameInfo.appendChild(oGameName);
		// 如果是新推荐的游戏，创建提示线索对象
		if (isNewGame) {
			var newHint = createNewHintElement();
			oDivGameInfo.appendChild(newHint);	
		}
		
		var oBr = document.createElement("br");
		oDivGameInfo.appendChild(oBr);
		
		var oFriendInfo = createFriendInfoElement(friendInfoStr);
		oDivGameInfo.appendChild(oFriendInfo);
		
		var oPlayerNumInfo = createPlayerNumElement(playerNum);
		oDivGameInfo.appendChild(oPlayerNumInfo);
		
//		var oGameIntro = createGameIntroElement();
//		oDivGameInfo.appendChild(oGameIntro);
		 
		var oDivStar = document.createElement("div");
		var idStr = createIdStr();
		oDivStar.setAttribute("id", idStr);
		
		oDivGameInfo.appendChild(oDivStar);
		 
		oDiv.appendChild(oDivGameInfo);
        oTd1.appendChild(oDiv);
        oTr.appendChild(oTd1);
		
		// 创建一个列对象
		var oTd3 = document.createElement("td"); 
		oTd3.setAttribute("scope", "col");
		oTd3.setAttribute("class", "column-star");
		oTd3.setAttribute("align", "right");
		
//		var oDivStar = document.createElement("div");
//		var idStr = createIdStr();
//		oDivStar.setAttribute("id", idStr);
//		
//		oTd3.appendChild(oDivStar);
		
		var oKuaiwan = createKuaiwanElement(gameUrl, false);
		oTd3.appendChild(oKuaiwan);
		
		oTr.appendChild(oTd3);
	
		var oScript = document.createElement("script");
		oScript.setAttribute("type", "text/javascript");
		oScript.innerHTML = "$('#" + idStr +"').raty({ path: 'star/images/', space: false, readOnly:true, score:" + gameScore + "} );";
		oDivRow.appendChild(oScript);
		
		return oDivRow;
	} else {
		mxLog("ERROR game-center.js : gameName or gameUrl or iconSrc or friendInfoStr is not correct!");
		return null;
	}
	
}

// 是否开启调试模式
var g_debug_mode = false;

// Public API
// 设置是否为调试模式
function setDebugMode(mode) {
	g_debug_mode = mode;
}

// Public API
// 获取是否为调试模式
function getDebugMode() {
	return g_debug_mode;
}

// 表示我的游戏中一页能显示的图标的个数
// 默认为4
var g_icon_count_per_page = 4;
// Public API
function getIconCountPerPage() {
	return g_icon_count_per_page;
}

// Public API
// 设置我的游戏中一页能显示的图标的个数
function setIconCountPerPage(count) {
	g_icon_count_per_page = count;
}


// Public API
// 获取用来调程序试的游戏信息数组
window.getDebugGameInfoArr = function () {
	// 游戏信息数组
	var gameInfoArr = [{
			gameName: "水果忍者",				
			gameUrl: "mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPWZydWl0",
			iconSrc: "images/fruit/fruit_256x256.png",
			isInDeletionMode : false,
			left: ""
		},
		{
			gameName: "Flappy Bird",
			gameUrl: "mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPWJpcmQ=",
			iconSrc: "images/flappy/flappy_256x256.png",
			isInDeletionMode : false,
			left: ""			
		},
		{
			gameName: "2048",
			gameUrl: "mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPTIwNDg=",
			iconSrc: "images/2048/2048_256x256.png",
			isInDeletionMode : false,
			left: ""
		},
		{
			gameName: "Pop Stars",
			gameUrl: "mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPXBvcHN0YXI=",
			iconSrc: "images/pop/pop_256x256.png",
			isInDeletionMode : false,
			left: ""
		},
		{
			gameName: "水果忍者",				
			gameUrl: "mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPWZydWl0",
			iconSrc: "images/fruit/fruit_256x256.png",
			isInDeletionMode : false,
			left: ""
		},
		{
			gameName: "Flappy Bird",
			gameUrl: "mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPWJpcmQ=",
			iconSrc: "images/flappy/flappy_256x256.png",
			isInDeletionMode : false,
			left: ""
		} 		
	];
	
	return gameInfoArr;
}

// 根据游戏发布的时间和当前时间，判断游戏是否为新游戏
// 7天以内发布的游戏都算作新游戏
function isNewGameWithDate(pubDate) {
	var currentDate = new Date();
	var newDate = new Date(pubDate);
	var date = newDate.getDate();
	newDate.setDate(date+7);
	
	var newGame = false;
	if (newDate > currentDate) {
		newGame = true;	
	}
	

	return newGame;
}

// Private API
// 将传入的JSON字符串转换为需要的对象
function getGameInfoArrFromJSON(myGameStr) {
	var oMyGameOrigin = JSON.parse(myGameStr);
	var oGameLists = oMyGameOrigin.gamelists;
	var length = oGameLists.length;
	var  gameInfoArr = [];
	for (var i=0; i<length; i++) {
		var gameInfoOrigin = oGameLists[i];
		var packageId = gameInfoOrigin.package_id;
		var resourceType = gameInfoOrigin.resource_type;
		var packageUrl = "http://wge.maxthon.cn/?package_id=" + packageId + "&" + "resource_type=" + resourceType;
		var mgeUrl = "mge://" + window.BASE64.encoder(packageUrl);
		var iconUrl = decodeURIComponent(gameInfoOrigin.local_icon_url);
		var rating = parseInt(gameInfoOrigin.rating);
		var time = gameInfoOrigin.SystemTime;
		var date = new Date(time);
		var newGame = isNewGameWithDate(date);
		var language = getLanguage();
		var detailSrc= decodeURIComponent(gameInfoOrigin[language + "_index"]);
		var num = gameInfoOrigin.player_num;
		var gameInfo = {
				gameName : gameInfoOrigin[language + "_name"],
				gameUrl : mgeUrl,
				iconSrc : iconUrl,
				isInDeletionMode : false,
				left: "",
				gameScore : rating,
				isNewGame : newGame,
				friendInfo : "暂时不显示",
				detailUrl : detailSrc,
				playerNum : num
		};
		
		gameInfoArr.push(gameInfo);
		
	}
	
	return gameInfoArr;
}

// Public API
window.createAllGameIconElement = function (parent, gameInfoArray, gameCount, sliderIndex) {
	if (parent && gameInfoArray) {
		setSlideDiv(parent);
		setGameInfoArr(gameInfoArray);
		
		parent.innerHTML = '<div id="myGameSlide"></div>';
		createAllGameIconElementInternal(parent.firstChild, gameInfoArray, gameCount, sliderIndex);
	}
}

// Private API
function createAllGameInfoElement(parent, recGameInfoArr) {
	if (parent && recGameInfoArr) {
		var length = recGameInfoArr.length;
		for (var i=0; i<length; i++) {
			var recGameInfo = recGameInfoArr[i];
			var gameName = recGameInfo.gameName;//"水果忍者";
			var gameUrl = recGameInfo.gameUrl;//"mge://aHR0cDovLzEwLjAuNi42Ny94YW1wcC9tZ2VkZW1vLz9uYW1lPWZydWl0";
			var iconSrc = recGameInfo.iconSrc;//"images/fruit/fruit_256x256.png";
			var isNewGame = recGameInfo.isNewGame;//true;
			var friendInfoStr = recGameInfo.friendInfo;//"有24位好友在玩";
			var gameScore = recGameInfo.gameScore;
			var detailUrl = recGameInfo.detailUrl;
			var playerNum = recGameInfo.playerNum;
			
			var oGameInfo = createGameInfoElement(gameName, gameUrl, iconSrc, isNewGame, friendInfoStr, gameScore, detailUrl, playerNum);
			parent.appendChild(oGameInfo);
		}		
	} else {
		mxLog("ERROR game-center.js : parent or recGameInfoArr is not correct!");
	}
	
}

// Private API
// 创建推荐游戏标题对应的div
//<div class="banner">
//	推荐游戏
//</div>
function createRecGameBanner() {
	var oDiv = document.createElement("div");
	oDiv.setAttribute("class", "banner");
	var languageInfo = getLanguageInfo();
	oDiv.innerHTML = languageInfo.recGameText;
	
	return oDiv;
}


// Private API
// 创建id为recGame的div节点的class为list的div节点
//<div class="list">
//	<div id="recGame">
//	</div> 
//</div>
function createRecGameContainer() {
	var oDiv = document.createElement("div");
	oDiv.setAttribute("class", "list");	
	var oChildDiv = document.createElement("div");
	oChildDiv.setAttribute("id", "recGame");
	
	oDiv.appendChild(oChildDiv);
	
	return oDiv;
}

// Private API
// 初始化游戏中心界面需要的节点
// 目前尚未支持我的游戏，以后需要
// 可以定义相应函数
function initGameCenterGUI() {
	var oBody = document.body;
	var oDivBanner = createRecGameBanner();
	oBody.appendChild(oDivBanner);
	
	var oDivContainer = createRecGameContainer();
	oBody.appendChild(oDivContainer);
}

// Private API
// 创建游戏中心的主界面
function createGameCenterGUI() {
	// 初始化游戏中心界面需要的节点
	initGameCenterGUI();
	
	// 从Java层获取游戏列表数据，1表示获取推荐游戏列表数据
	var myGameStr = mgeJS.getGameList(1);
	var oGameInfoArr = getGameInfoArrFromJSON(myGameStr);

	var oRecGame = document.getElementById("recGame");
	createAllGameInfoElement(oRecGame, oGameInfoArr);

}

createGameCenterGUI();
})();