(function (){
// Private API
// 1. window.mgeJS应该由Java程序提供定义
// 如果不存在，则定义其为一个对象，方便
// 在Java程序不存在的情况下进行调试
// 2. mgeJS.getGameList也应该由Java程序
// 提供
// 3. 只有当是Windows桌面浏览器时才需要进行
// 这样的定义。这个是为了方便在PC浏览器中进行调试。
if (window.navigator.userAgent.indexOf("Windows")>-1) {
	window.mgeJS = window.mgeJS || {};
	mgeJS.getGameList = mgeJS.getGameList || function () {
		var myGameStr = '{"version":"28","page":1,"gamelists":[{"package_id":"59","zh_name":"\u50cf\u7d20\u9e1f","en_name":"Flappy Bird","version":"1.0","rating":"4","md5":"560b64ad8d9b048c00a7c03a82ac0296","support_sdk":"1.0","size":"123213","download_url":"http%3A%2F%2Fwge.maxthon.cn%2Fgames%2Fflappybird%2Fbird.zip","icon_url":"http%3A%2F%2Fwge.maxthon.cn%2Fgames%2Fflappybird%2F72.png","orientation":"portrait","packtool_id":"1","resource_type":"1","SystemTime":1414579073,"zh_index":"http%3A%2F%2Fwge.maxthon.cn%2Fgames%2Fflappybird%2Fzh%2Fgame_detail.html","zh_index_update":1414579073,"en_index":"http%3A%2F%2Fwge.maxthon.cn%2Fgames%2F","en_index_update":false, "player_num":"0"},{"package_id":"60","zh_name":"\u5207\u6c34\u679c","en_name":"fruit","version":"1.0","rating":"4","md5":"4dcfd5aa43f1c3c7da85f207abd0d64c","support_sdk":"1.0","size":"1389031","download_url":"http%3A%2F%2Fwge.maxthon.cn%2Fgames%2Ffruit%2Ffruit.zip","icon_url":"http%3A%2F%2Fwge.maxthon.cn%2Fgames%2Ffruit%2F72.png","orientation":"landscape","packtool_id":"1","resource_type":"1","SystemTime":1414579078,"zh_index":"http%3A%2F%2Fwge.maxthon.cn%2Fgames%2Ffruit%2Fzh%2Fgame_detail.html","zh_index_update":1414579078,"en_index":"http%3A%2F%2Fwge.maxthon.cn%2Fgames%2F","en_index_update":false,"player_num":"0"},{"package_id":"61","zh_name":"2048","en_name":"2048","version":"1.0","rating":"4","md5":"a985864a9db1b31b1693abf8e2974560","support_sdk":"1.0","size":"24142","download_url":"http%3A%2F%2Fwge.maxthon.cn%2Fgames%2F2048%2F2048.zip","icon_url":"http%3A%2F%2Fwge.maxthon.cn%2Fgames%2F2048%2F72.png","orientation":"portrait","packtool_id":"1","resource_type":"1","SystemTime":1415675934,"zh_index":"http%3A%2F%2Fwge.maxthon.cn%2Fgames%2F","zh_index_update":false,"en_index":"http%3A%2F%2Fwge.maxthon.cn%2Fgames%2F","en_index_update":false, "player_num":"0"}]}';
	
		return myGameStr;
	};
	
	mgeJS.getSystemLanguage = mgeJS.getSystemLanguage || function () {
		return "zh";
	}
}



var g_language = null;
window.getLanguage = function () {
	if (!g_language) {
		var language = mgeJS.getSystemLanguage().toLowerCase();
		if (language) {
			g_language = language.substr(0, 2);
		} else {
			g_language = "zh";	
		}
	}
	
	return g_language;
}

// 创建script节点，当表示语言文件的JS加载完成后创建
// 该节点加载game-center.js
window.createScriptForGameCenter = function () {
	var oScript = document.createElement("script");
	oScript.type = "text/javascript";
	oScript.src = "js/game-center.js";
	oScript.setAttribute("defer", "defer");

	var oHeads = document.getElementsByTagName("head");
	var oHead = oHeads[0];

	oHead.appendChild(oScript);
}

// 创建script节点，根据系统语言类型导入相应的JS文件
function createScriptForLanguage() {
	var oScript = document.createElement("script");
	oScript.type = "text/javascript";
	var language = getLanguage();	
	oScript.src = "js/" + language + ".js";	
	
	oScript.setAttribute("onload", "createScriptForGameCenter()");
	
	var oHeads = document.getElementsByTagName("head");
	var oHead = oHeads[0];

	oHead.appendChild(oScript);
}

function init() {
	createScriptForLanguage();
}

init();
})();
